-- Magic Carpet lua file

local clickOffset = {x = 0, y = 0}
local mcarpet_Placement = {x = UIParent:GetRight()-(64 + 512), y = 285}
local lastFrameTime = 0
local context = UI.CreateContext("MCarpet")

local magicYOffset = 0.2004681331

local window = UI.CreateFrame("RiftWindow", "MainWindow", context)
window:SetTitle("Magic Carpet")
window:SetWidth(200)
window:SetHeight(400)

window.dragActive = false

local mcarpetDrag = UI.CreateFrame("Frame", "drag frame", window)
mcarpetDrag:SetAllPoints()

local closeButton = UI.CreateFrame("RiftButton", "CloseButton", window)
closeButton:SetSkin("close")
closeButton:SetPoint("TOPRIGHT", window, "TOPRIGHT", 0, 12)
closeButton:SetLayer(100)

function closeButton.Event:LeftPress()
	window:SetVisible(false)
end

local placeButton = UI.CreateFrame("RiftButton", "PlaceButton", window)
placeButton:SetPoint("TOPCENTER", window, "TOPCENTER", 0, 50)
placeButton:SetText("Place")
placeButton:SetLayer(100)

local pickupButton = UI.CreateFrame("RiftButton", "PickupButton", window)
pickupButton:SetPoint("TOPCENTER", window, "TOPCENTER", 0, 80)
pickupButton:SetText("Pick Up")
pickupButton:SetLayer(100)
pickupButton:SetEnabled(false)

local pitchButtons = {}

for i = 1, 9, 1 do
  pitchButtons[i] = UI.CreateFrame("RiftButton", "PitchButton"..i, window)
  pitchButtons[i]:SetPoint("TOPCENTER", window, "TOPCENTER", 0, 122 + ((i-1)*27))
  local labelText = tostring(5-i)
  if 5-i > 0 then
    labelText = "+"..labelText
  end
  pitchButtons[i]:SetText(labelText)
  pitchButtons[i]:SetLayer(100)
  if i == 5 then
    pitchButtons[i]:SetEnabled(false)
  end
end

function mcarpetDrag.Event:LeftDown()
  window.dragActive = true
  local mouseStatus = Inspect.Mouse()
  clickOffset["x"] = mouseStatus.x - mcarpet_Placement["x"]
  clickOffset["y"] = mouseStatus.y - mcarpet_Placement["y"]
end

function mcarpetDrag.Event:LeftUp()
       window.dragActive = false
end

function mcarpetDrag.Event:LeftUpoutside()
       window.dragActive = false
end

function mcarpetDrag.Event:MouseMove(x,y)
       if window.dragActive == true then
              mcarpet_Placement["x"] = x - clickOffset["x"]
              mcarpet_Placement["y"] = y - clickOffset["y"]	
              window:SetPoint("TOPLEFT", context, "TOPLEFT", mcarpet_Placement["x"], mcarpet_Placement["y"])
       end
end

function AddOnLoadComplete(addOnName)
       if addOnName == "MCarpet" then
              window:SetPoint("TOPLEFT", context, "TOPLEFT", mcarpet_Placement["x"], mcarpet_Placement["y"])  
              window:SetVisible(false)
       end
end

table.insert(Event.Addon.Load.End, {AddOnLoadComplete, "MCarpet", "LoadComplete"})

local lastPlayerPos = {coordX = 0, coordY = 0, coordZ = 0}
local olderPlayerPos = lastPlayerPos
local evenOlderPlayerPos = olderPlayerPos
local lastCarpetMove = 0
local lastYaw = 0

desiredPitch = 0

local function tick()
  local currentFrameTime = Inspect.Time.Frame()
  local deltaT = currentFrameTime - lastFrameTime

  lastFrameTime = currentFrameTime

  if carpetId ~= "d" then
    local playerDetails = Inspect.Unit.Detail("player")
    local xDiff = playerDetails["coordX"] - lastPlayerPos["coordX"]
    local yDiff = playerDetails["coordY"] - lastPlayerPos["coordY"]
    local zDiff = playerDetails["coordZ"] - lastPlayerPos["coordZ"]
    if math.abs(xDiff) > 0.001 or
      math.abs(yDiff) > 0.02 or  
      math.abs(zDiff) > 0.001 then
          
      if playerDetails["coordX"] ~= lastPlayerPos["coordX"] or playerDetails["coordY"] ~= lastPlayerPos["coordY"] or playerDetails["coordZ"] ~= lastPlayerPos["coordZ"] then   
        lastCarpetMove = currentFrameTime
        local update = {}
        update["coordX"] = playerDetails["coordX"]
        update["coordY"] = playerDetails["coordY"] - magicYOffset
		-- 0.2044681331
        update["coordZ"] = playerDetails["coordZ"]
            
        if desiredPitch > 0 then
          update["coordY"] = update["coordY"] - desiredPitch * 0.125
        end
            
            if math.abs(xDiff) > 0.01 or math.abs(zDiff) > 0.01 then
              if olderPlayerPos["coordX"] ~= 0 then
                update["yaw"] = math.atan2(playerDetails["coordZ"] - evenOlderPlayerPos["coordZ"], playerDetails["coordX"] - evenOlderPlayerPos["coordX"]) + (math.pi / 2)
              else
                update["yaw"] = math.atan2(zDiff, xDiff) + (math.pi / 2)
              end
              
              if update["yaw"] > math.pi then
                update["yaw"] = update["yaw"] - 2 * math.pi
              end
              
              if update["yaw"] < -math.pi then
                update["yaw"] = update["yaw"] + 2 * math.pi
              end  
              
              local yawDiff = math.abs(update["yaw"] - lastYaw)
              if yawDiff > 2 * math.pi then
                yawDiff = yawDiff - 2 * math.pi
              end
              
              if yawDiff < 0.105 then
                update["yaw"] = lastYaw
              end
              lastYaw = update["yaw"]
              
              while lastYaw > math.pi do
                lastYaw = lastYaw - math.pi * 2
              end
              
              while lastYaw < -math.pi do
                lastYaw = lastYaw + math.pi * 2
              end
              
              --if desiredPitch ~= 0 then
                -- MakeZRotation
                local zMatrix = {}
                zMatrix[0] = {}
                zMatrix[1] = {}
                zMatrix[2] = {}
                
                local sn = math.sin(desiredPitch)
                local cs = math.cos(desiredPitch)
                
                zMatrix[0][0] = cs
                zMatrix[0][1] = sn
                zMatrix[0][2] = 0
                zMatrix[1][0] = -sn
                zMatrix[1][1] = cs
                zMatrix[1][2] = 0
                zMatrix[2][0] = 0
                zMatrix[2][1] = 0
                zMatrix[2][2] = 1
                
                local yMatrix = {}
                yMatrix[0] = {}
                yMatrix[1] = {}
                yMatrix[2] = {}
                
                sn = math.sin(lastYaw)
                cs = math.cos(lastYaw)
                
                yMatrix[0][0] = cs
                yMatrix[0][1] = 0
                yMatrix[0][2] = -sn
                yMatrix[1][0] = 0
                yMatrix[1][1] = 1
                yMatrix[1][2] = 0
                yMatrix[2][0] = sn
                yMatrix[2][1] = 0
                yMatrix[2][2] = cs
                
                local aMatrix = zMatrix
                local bMatrix = yMatrix
                
                local rMatrix = {}
                rMatrix[0] = {}
                rMatrix[1] = {}
                rMatrix[2] = {}
                
                rMatrix[0][0] = aMatrix[0][0]*bMatrix[0][0] + aMatrix[0][1]*bMatrix[1][0] + aMatrix[0][2]*bMatrix[2][0]
                rMatrix[1][0] = aMatrix[1][0]*bMatrix[0][0] + aMatrix[1][1]*bMatrix[1][0] + aMatrix[1][2]*bMatrix[2][0]
                rMatrix[2][0] = aMatrix[2][0]*bMatrix[0][0] + aMatrix[2][1]*bMatrix[1][0] + aMatrix[2][2]*bMatrix[2][0]
                rMatrix[0][1] = aMatrix[0][0]*bMatrix[0][1] + aMatrix[0][1]*bMatrix[1][1] + aMatrix[0][2]*bMatrix[2][1]
                rMatrix[1][1] = aMatrix[1][0]*bMatrix[0][1] + aMatrix[1][1]*bMatrix[1][1] + aMatrix[1][2]*bMatrix[2][1]
                rMatrix[2][1] = aMatrix[2][0]*bMatrix[0][1] + aMatrix[2][1]*bMatrix[1][1] + aMatrix[2][2]*bMatrix[2][1]
                rMatrix[0][2] = aMatrix[0][0]*bMatrix[0][2] + aMatrix[0][1]*bMatrix[1][2] + aMatrix[0][2]*bMatrix[2][2]
                rMatrix[1][2] = aMatrix[1][0]*bMatrix[0][2] + aMatrix[1][1]*bMatrix[1][2] + aMatrix[1][2]*bMatrix[2][2]
                rMatrix[2][2] = aMatrix[2][0]*bMatrix[0][2] + aMatrix[2][1]*bMatrix[1][2] + aMatrix[2][2]*bMatrix[2][2]

                
                --rMatrix = yMatrix
                
                local rfxAngle = 0
                local rfyAngle = 0
                local rfzAngle = 0
                
                rfyAngle = -math.asin(rMatrix[0][2])
                if rfyAngle < math.pi/2 then
                  if rfyAngle > -math.pi/2 then
                    rfxAngle = -math.atan2(-rMatrix[1][2], rMatrix[2][2])
                    rfzAngle = -math.atan2(-rMatrix[0][1], rMatrix[0][0])
                  else
				    local frmy = math.atan2(rMatrix[1][0], rMatrix[1][1])
                    rfzAngle = 0
                    rfxAngle = frmy - rfzAngle
                  end
                else
                  local frpy = math.atan2(rMatrix[1][0], rMatrix[1][1])
                  rfzAngle = 0
                  rfxAngle = rfzAngle - frpy
                end
                  
                update["pitch"] = rfzAngle
                update["roll"] = rfxAngle
                update["yaw"] = rfyAngle
            end
            
     
            Command.Dimension.Layout.Place(carpetId, update)
            
            evenOlderPlayerPos = olderPlayerPos
            olderPlayerPos = lastPlayerPos
            
            lastPlayerPos["coordX"] = playerDetails["coordX"]
            lastPlayerPos["coordY"] = playerDetails["coordY"]
            lastPlayerPos["coordZ"] = playerDetails["coordZ"]
          end
          end
        end
       
end

carpetId = "d"

table.insert(Event.System.Update.Begin, {tick, "MCarpet", "refresh"})

function togglewindow()
	window:SetVisible(not window:GetVisible())
end

table.insert(Command.Slash.Register("Carpet"), {togglewindow, "MCarpet", "toggle"})

function AdjustPitch(newVal)
	for i = 1, 9, 1 do
		if i == newVal then
		    pitchButtons[i]:SetEnabled(false)	
		else
		    pitchButtons[i]:SetEnabled(true)	
		end
	end
	desiredPitch = (-5+newVal)/10
end

for i = 1, 9, 1 do
	pitchButtons[i].Event.LeftPress = function() AdjustPitch(i) end
end

local waitingForCarpet = false
local rugType = "IFD110EF87F18F4D6,CA035331CDAA847F,,,,,,"

function placeButton.Event:LeftPress()
	
	local items = Inspect.Item.List()
	for slot, id in pairs(items) do
	    if id ~= false then
			local data = Inspect.Item.Detail(id)
			if data.type == rugType then
				placeButton:SetEnabled(false)
				pickupButton:SetEnabled(true)
				waitingForCarpet = true
				Command.Dimension.Layout.Place(id, {scale=12})
				return
			end
		end
    end
	
	dump("You do not seem to have an Ochre Rug in your inventory!")
end

function pickupButton.Event:LeftPress()
	placeButton:SetEnabled(true)
	pickupButton:SetEnabled(false)
	
	if carpetId ~= "d" then
		Command.Dimension.Layout.Pickup(carpetId)
		carpetId = "d"
	end
end

function dimensionItemAdded(dimensionItem)
	if waitingForCarpet == true then
	    for id, value in pairs(dimensionItem) do
			local data = Inspect.Dimension.Layout.Detail(id)
			if data ~= nil then
				if data.type == rugType then
					carpetId = id
					waitingForCarpet = false
					
					magicYOffset = Inspect.Unit.Detail("player").coordY - Inspect.Dimension.Layout.Detail(id).coordY
					magicYOffset = magicYOffset + 0.2
				end
			end
		end
	end
end

table.insert(Event.Dimension.Layout.Add, {dimensionItemAdded, "MCarpet", "dimensionItemAdded"})



